/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package java8tests;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Stream;

/**
 *
 * @author micha
 */
public class Java8Tests {

    List<String> liste = Arrays.asList("eins", "zwei", "drei", "vier", "alaaaf");

    void tuWas() {

        //lambda-ausdruecke als parameter der funktion replaceAll() und forEach():
        liste.replaceAll(e -> e + "e");
        liste.sort((x, y) -> y.compareTo(x));
        liste.forEach(e -> System.out.println(e));

        liste.forEach(e -> Drucker.drucken(e));
        System.out.println("---");
        liste.forEach(Drucker::drucken);

        //Stream.generate(() -> Math.random()).forEach(d -> System.out.println(d));
        Stream<Double> stream5 = Stream.generate(() -> Math.random());
        Stream<Double> stream = Stream.of(10.1, 3.2, 2.4, 1.2, 1.66);
        stream
                .map(d -> Math.round(d * (13 / 7)))
                .filter(d -> d > 1)
                .sorted((c, d) -> (int) (d - c))
                .forEach(d -> System.out.println(d));

        Stream<Double> stream2 = Stream.of(10.1, 3.2, 2.4, 1.2, 1.66);

        System.out.printf("anzahl: %d\n",
                stream2
                .map(d -> Math.round(d * (13 / 7)))
                .filter(d -> d > 1)
                .sorted((c, d) -> (int) (d - c))
                .count()
        );

        stream2 = Stream.of(1.1, 2.2, 3.3, 4.4, 5.5);

        System.out.println(
                stream2
                //.map(d -> Math.round(d * (13 / 7)))
                //.filter(d -> d > 1)
                //.sorted((c, d) -> (int)(d-c))
                .reduce(0.0, (l, e) -> l + e)
        );

        System.out.printf("zufallssumme: %f \n",
                stream5.limit(10).reduce(0.0, (a, b) -> a + b));

        Stream<Double> stream3 = Stream.generate(() -> Math.random());

        //Stream.generate(() -> Math.random()).filter(d -> 0.5 < d).forEach(d -> System.out.println(d));
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        new Java8Tests().tuWas();
    }

}
